# gui.py
# basiert auf gui.py von Raumplaner-Gui-Integration-Schritte-4.zip
# Bearbeitung:
# - Einbau des GridBagSizers (aus Demo)
# - Breite und Hoehe angepasst
# - Ereignisbehandlung fuer die EVT_TEXT_ENTER
#   die ist noch unvollstaendig
#   weiterhin fehlt die Vervollstaendigung der Menues

import wx

from raumplanerModell import RaumplanerModell

### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=(450,50), # neu
            size=(250,540), style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        self.__modell = None
        panel = wx.Panel(self, -1)

        gbs = self.gbs = wx.GridBagSizer(vgap=5, hgap=5) # neu

        ### Label (StaticText) und TextCtrl
        ### Achtung: Erzeugen und Einbau in gbs hier getrennt !!!
        label1 = wx.StaticText(panel, -1, "ausgewählt:")
        ##self.label1.SetPosition((155, 15)) alle raus !!!
        self.labelName = wx.StaticText(panel, -1, "") # muss gesetzt werden
        ## Datenbereich
        labelX = wx.StaticText(panel, -1, "x-Position")
        self.textCtrlX = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(125, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        labelY = wx.StaticText(panel, -1, "y-Position")
        self.textCtrlY = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(125, -1),
                                     style=wx.TE_PROCESS_ENTER)
        labelB = wx.StaticText(panel, -1, "Breite")
        self.textCtrlB = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(125, -1),
                                     style=wx.TE_PROCESS_ENTER)
        labelT = wx.StaticText(panel, -1, "Tiefe")
        self.textCtrlT = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(125, -1),
                                     style=wx.TE_PROCESS_ENTER)
        labelW = wx.StaticText(panel, -1, "Winkel")
        self.textCtrlW = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(125, -1),
                                     style=wx.TE_PROCESS_ENTER)
        labelF = wx.StaticText(panel, -1, "Farbe")
        self.textCtrlF = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(125, -1),
                                     style=wx.TE_PROCESS_ENTER)
        
        ### Button-Abschnitt
        waehleButton = wx.Button(panel, 1001, "wähle")        
        beendenButton = wx.Button(panel, 1003, "Beenden")
        
        ### Aufbau in gbs definieren
        gbs.Add(label1, (0,0), flag=wx.ALL, border=10)
        gbs.Add(self.labelName, (0,1), flag=wx.ALL, border=10)
        gbs.Add(labelX, (1,0), flag=wx.ALL, border=10)
        gbs.Add(self.textCtrlX, (1,1), flag=wx.ALL, border=10)
        gbs.Add(labelY, (2,0), flag=wx.ALL, border=10)
        gbs.Add(self.textCtrlY, (2,1), flag=wx.ALL, border=10)
        gbs.Add(labelB, (3,0), flag=wx.ALL, border=10)
        gbs.Add(self.textCtrlB, (3,1), flag=wx.ALL, border=10)
        gbs.Add(labelT, (4,0), flag=wx.ALL, border=10)
        gbs.Add(self.textCtrlT, (4,1), flag=wx.ALL, border=10)
        gbs.Add(labelW, (5,0), flag=wx.ALL, border=10)
        gbs.Add(self.textCtrlW, (5,1), flag=wx.ALL, border=10)
        gbs.Add(labelF, (6,0), flag=wx.ALL, border=10)
        gbs.Add(self.textCtrlF, (6,1), flag=wx.ALL, border=10)
        
        gbs.Add(waehleButton, (7,0), flag=wx.ALL, border=10)
        gbs.Add(beendenButton, (7,1), flag=wx.ALL, border=10)


        panel.SetSizerAndFit(gbs)

        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnterX, self.textCtrlX)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnterY, self.textCtrlY)
##        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnterB, self.textCtrlB)
##        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnterT, self.textCtrlT)
##        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnterW, self.textCtrlW)
##        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnterF, self.textCtrlF)

        self.Bind(wx.EVT_BUTTON, self.OnWaehle, waehleButton)
        self.Bind(wx.EVT_BUTTON, self.OnBeenden, beendenButton)
        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)


        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # erstes Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(103, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")

        # zweites Menue
        neuMenu = wx.Menu()
        neuMenu.Append(201, "Stuhl", "")
        neuMenu.Append(202, "Tisch", "")
        neuMenu.Append(203, "Schrank", "")
        ##neuMenu.AppendSeparator()
        # Add menu to the menu bar
        menuBar.Append(neuMenu, "&Moebel")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=103)

        self.Bind(wx.EVT_MENU, self.OnStuhl, id=201)
        self.Bind(wx.EVT_MENU, self.OnTisch, id=202)
        self.Bind(wx.EVT_MENU, self.OnSchrank, id=203)

    def SetzeModell(self,modell):
        self.__modell = modell

    ### Ereignisbehandlung ###
    ### TextCtrl
    def OnTextEnterX(self, event):
        ausgewaehlt=self.__modell.GibAusgewaehltes()
        if ausgewaehlt==None: return
        alterWert=ausgewaehlt.GibX()
        inhalt=self.textCtrlX.GetValue() # neu
        try:
            neuerWert=int(inhalt)  # neu!
            self.__modell.BewegeHorizontal(neuerWert-alterWert)
        except ValueError as e:
            self.textCtrlX.SetValue('Eingabefehler')
            return

    def OnTextEnterY(self, event):
        ausgewaehlt=self.__modell.GibAusgewaehltes()
        if ausgewaehlt==None: return
        alterWert=ausgewaehlt.GibY()
        inhalt=self.textCtrlY.GetValue() # neu
        try:
            neuerWert=int(inhalt)  # neu!
            self.__modell.BewegeVertikal(neuerWert-alterWert)
        except ValueError as e:
            self.textCtrlY.SetValue('Eingabefehler')
            return
##### ----- hier fehlen die weiteren ---------------------
        
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        self.__modell.Lade('Daten/daten_1.dat')

    def OnSpeichern(self, event):
        self.__modell.Speichere('Daten/daten_1.dat')

    def OnStuhl(self, event):
        self.__modell.Neu('Stuhl', sichtbar=True)

    def OnTisch(self, event):
        self.__modell.Neu('Tisch', sichtbar=True)

    def OnSchrank(self, event):
        self.__modell.Neu('Schrank', sichtbar=True)


    ### Button-Abschnitt
    def OnWaehle(self, event):        
        ausgewaehlt=self.__modell.Waehle()
        if ausgewaehlt==-1:
            self.labelName.SetLabel('') # neu
            self.textCtrlX.SetValue('')
            self.textCtrlY.SetValue('')
            self.textCtrlB.SetValue('')
            self.textCtrlT.SetValue('')
            self.textCtrlW.SetValue('')
            self.textCtrlF.SetValue('')
            return
        if type(ausgewaehlt)==int: ausgewaehlt+=1
        self.labelName.SetLabel(str(ausgewaehlt)) # neu
        aktuell=self.__modell.GibAusgewaehltes()
        self.textCtrlX.SetValue(str(aktuell.GibX()))
        self.textCtrlY.SetValue(str(aktuell.GibY()))
        self.textCtrlB.SetValue(str(aktuell.GibBreite()))
        self.textCtrlT.SetValue(str(aktuell.GibTiefe()))
        self.textCtrlW.SetValue(str(aktuell.GibOrientierung()))
        self.textCtrlF.SetValue(aktuell.GibFarbe())
        
    
    def OnDrehe(self, event):
        self.__modell.Drehe(30)
    
    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Anwendung fuer Raumplaner"""
    def OnInit(self):
        self.fenster = Gui(None, 1000, "Raumplaner")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    app.MainLoop()
